/* first create by zhang.ruikang, thanks layui */

layui.use(['element', 'form', 'upload'], function(){
    var $ = layui.$;
    var element = layui.element;
    var form = layui.form;
    var api  = "/cgi-bin/App/opser/process";
    var upload = layui.upload;

    //ԶУ
    form.verify({
        isport: function(value, item){
            if(!IsDigitIn(value, 0, 65535))
                return '˿ڷΧ0-65535';
        }
        ,n_isport: function(value, item){
            if(value!="" && !IsDigitIn(value, 0, 65535))
                return '˿ڷΧ0-65535';
        }
        ,isipaddr: function(value, item){
            if(!IsIPAddr(value))
                return "IPַ";
        }
        ,n_isipaddr: function(value, item){
            if(value != "" && !IsIPAddr(value))
                return "IPַ";
        }
        ,isiprange: function(value, item){
            try{
                var ip = value.split("-");
                if(!IsIPAddr(ip[0])||!IsIPAddr(ip[1]))
                    return "IPΧ";
            }catch(err) {
                return "IPΧ";
            }
        }
        ,n_isiprange: function(value, item){
            try{
                if(value != ""){
                    var ip = value.split("-");
                    if(!IsIPAddr(ip[0])||!IsIPAddr(ip[1]))
                        return "IPΧ";
                }
            }catch(err) {
                return "IPΧ";
            }
        }
    });

    //ԶЭ飬
    form.on('submit(ApxAddDns)', function(data){
        layer.confirm('ȷҪύ', {icon: 3, title:"ʾ"}, 
        function(index) {
            var load = layer.load(1, {shade: [0.1,'#fff']}, {time: 10*1000});
            data.field.action = "apx_add_url";
            Ajax(data.field, load);
        });
        return false;
    });
    
    //Эڵ
    form.on('submit(addAppNode)', function(data){
        layer.confirm('ȷҪύ', {icon: 3, title:"ʾ"}, 
        function(index) {
            var load = layer.load(1, {shade: [0.1,'#fff']}, {time: 10*1000});
            data.field.action = "app_add_node";
            Ajax(data.field, load);
        });
        return false;
    });

    //αIPб
    form.on('submit(addIp)', function(data){
        layer.confirm('ȷҪύ', {icon: 3, title:"ʾ"}, 
        function(index) {
            var load = layer.load(1, {shade: [0.1,'#fff']}, {time: 10*1000});
            data.field.action = "wei_iplist_add";
            Ajax(data.field, load);
        });
        return false;
    });

    //޸ز
    form.on('submit(SetPolicy)', function(data){
        if(parseInt(data.field.policy_startnum) > parseInt(data.field.policy_endnum)){
            layer.msg("ʼŲܴڽ", {icon: 2});
            return false;
        }
        data.field.policy_grp = encodeURI(data.field.policy_grp);
        layer.confirm('ȷҪύ', {icon: 3, title:"ʾ"}, 
        function(index) {
            var load = layer.load(1, {shade: [0.1,'#fff']}, {time: 10*1000});
            data.field.action = "setpolicy";
            Ajax(data.field, load);
        });
        return false;
    });

    //ɾỰ
    form.on('submit(flowDel)', function(data){
        var d = data.field;
        if(d.sessin_del_mode == "quickly" && d.qdel_ip_type == "many_ip"){
            //ɾһIP;
            if(d.q_srcip_range == ""){
                layer.msg("IPΧ", {icon: 2});
                return false;
            }
            var start_ip = ipToNumber(d.q_srcip_range.split("-")[0]);
            var end_ip = ipToNumber(d.q_srcip_range.split("-")[1]);
            var distance = end_ip - start_ip;
            if(distance <= 0){
                layer.msg("IPΧ", {icon:2});
                return false;
            }
            if(distance >= 200){
                layer.msg("IPΧܴ200", {icon:2});
                return false;
            }
            var iplist = new Array();
            for(i=start_ip; i<=end_ip; i++){
                iplist.push(numberToIp(i));
            }
            data.field.iprange = iplist.toString();
        }
        if(d.sessin_del_mode == "quickly" && d.qdel_ip_type == "one_ip"){
            //ɾIP;
            if(d.q_srcip_one == ""){
                layer.tips('ҪɾIP', '#q_srcip_one');
                return false;
            }
        }
        if(d.sessin_del_mode == "accurate"){
            //ȷɾ;
            if(d.a_srcip == "" && d.a_dstip == "" && d.a_dst_port == ""){  
                layer.msg('һҪ', {icon: 2});
                return false;
            }
        }
        layer.confirm('ȷҪύ', {icon: 3, title:"ʾ"}, 
        function(index) {
            var load = layer.load(1, {shade: [0.1,'#fff']}, {time: 10*1000});
            data.field.action = "clearflow";
            Ajax(data.field, load);
        });
        return false;
    });
    
    //ָ
    form.on('submit(restore_init)', function(data){
        layer.confirm('ȷҪָ', {icon: 3, title:"ʾ"}, 
        function(index) {
            if(data.field.password != data.field.password2) {
                layer.msg("벻һ", {icon: 2});
                return false;
            }
            var load = layer.load(1, {shade: [0.1,'#fff']}, {time: 10*1000});
            data.field.action = "restore_init";
            Ajax(data.field, load);
        });
        return false;
    });

    //ԶЭļϴ
    var uploadInst = upload.render({
        elem: '#ApxAddDns_file'
        ,accept: "file"
        ,acceptMime: "*/txt, */conf"
        ,exts: "txt|conf"
        ,url: api + "?action=apx_addurl_upfile" 
        ,before: function(obj) {
            obj.preview(function(index, file, result){
                $("#show_axpdns_file").hide();
                $("#show_axpdns_file").html(file.name);
            });
        }
        ,done: function(res){
            if(res.code == 0) {
                form.val("ApxAddDns", {"file_name": res.msg});
                $("#show_axpdns_file").show();
            } else
                layer.msg(res.msg, {icon: 2, anim: 6});
        }
        ,error: function(){}
    });

    //Эڵļϴ
    var uploadInst = upload.render({
        elem: '#addAppNode_file'
        ,accept: "file"
        ,acceptMime: "*/txt, */conf"
        ,exts: "txt|conf"
        ,url: api + "?action=app_addnode_upfile" 
        ,before: function(obj) {
            obj.preview(function(index, file, result){
                $("#show_appnode_file").hide();
                $("#show_appnode_file").html(file.name);
            });
        }
        ,done: function(res){
            if(res.code == 0) {
                form.val("addAppNode", {"file_name": res.msg});
                $("#show_appnode_file").show();
            } else
                layer.msg(res.msg, {icon: 2});
        }
        ,error: function(){}
    });

    //αIPбϴļ
    var uploadInst = upload.render({
        elem: '#addIp_file'
        ,accept: "file"
        ,acceptMime: "*/txt, */conf"
        ,exts: "txt|conf"
        ,url: api + "?action=wei_iplist_upfile" 
        ,before: function(obj) {
            obj.preview(function(index, file, result){
                $("#show_iplist_file").hide();
                $("#show_iplist_file").html(file.name);
            });
        }
        ,done: function(res){
            if(res.code == 0) {
                form.val("addIp", {"file_name": res.msg});
                $("#show_iplist_file").show();
            } else
                layer.msg(res.msg, {icon: 2});
        }
        ,error: function(){}
    });
    
    //Э
    $("#appname").click(function(){
        var url = "/cgi-bin/Setup/app_select";
        var retval = ShowDialog(url, "", 500, 600);
        if (retval == "NONE") return;
        var ar = retval.split(",");
        if (ar.length != 2) {
            layer.msg("Чķֵ");
            return;
        }
        var appid = document.getElementsByName("appid")[0];
        var appname = document.getElementsByName("appname")[0];
        appid.value = ar[0];
        appname.value = ar[1];
    });

    //ɾͱ仯
    form.on("select(sessin_del_mode)", function(data){
        if(data.value == "accurate") {
            $("#session_del_quick_val").hide();
            $("#session_del_accurate_val").show();
        } else if(data.value == "quickly") {
            $("#session_del_quick_val").show();
            $("#session_del_accurate_val").hide();
        }
    });

    //IPͱ仯
    form.on("select(qdel_ip_type)", function(data){
        if(data.value == "one_ip") {
            $("#del_iptype_many").hide();
            $("#del_iptype_one").show();
        } else if(data.value == "many_ip") {
            $("#del_iptype_many").show();
            $("#del_iptype_one").hide();
        }
    });

    //װAJAX
    function Ajax(data, load) {
        act = data.action;
        var uri = "?";
        var keylist = Object.keys(data);
        for(var i = 0; i <= (keylist.length - 1); i++){
            key = keylist[i];
            if(i == ( keylist.length -1 ))
                uri = uri + key + "=" + data[key];
            else
                uri = uri + key + "=" + data[key] + "&";
        }
        AJXS({
            type: 'POST',
            url: api + uri,
            error: function(status){
                layer.close(load); 
                layer.msg("", {icon: 2});  
            },
            success: function(data) {
                data = eval("("+data+")");
                layer.close(load);  
                if ( data.code == "1" ) {
                    layer.msg(data.msg, {icon: 2});
                    return
                }
                if(act == "restore_init"){
                    layer.open({title: 'ʾ', content: data.msg}, {icon: 2});
                    return;
                }
                layer.msg(data.msg, {icon: 1});
                $("#show_axpdns_file").html("");
                $("#show_appnode_file").html("");
                $("#show_iplist_file").html("");
            }
        });
    }

    function ipToNumber(ip) { 
        var num = 0; 
        if(ip == "") { 
            return num; 
        }   
        var aNum = ip.split(".");  
        if(aNum.length != 4) { 
            return num; 
        }   
        num += parseInt(aNum[0]) << 24; 
        num += parseInt(aNum[1]) << 16; 
        num += parseInt(aNum[2]) << 8; 
        num += parseInt(aNum[3]) << 0; 
        num = num >>> 0;
        return num;  
    }   
   
    function numberToIp(number) {   
        var ip = ""; 
        if(number <= 0) { 
            return ip; 
        }
        var ip3 = (number << 0 ) >>> 24; 
        var ip2 = (number << 8 ) >>> 24; 
        var ip1 = (number << 16) >>> 24; 
        var ip0 = (number << 24) >>> 24 
        ip += ip3 + "." + ip2 + "." + ip1 + "." + ip0; 
        return ip;   
    }

    //ҳʼ
    function initPage() {
        $.ajax({
            url: api,
            type: 'POST',
            dataType: 'json',
            data:{"action": "load_baseinfo"},
            error: function(xhr, type){},
            success: function(data){
                for(var i=0; i<data.data.userapp.length; i++){
                    var val = data.data.userapp[i];
                    html = "<option value="+val.appid+">"+val.appname+"</option>";
                    $("#track_app").append(html);
                }
                for(var i=0; i<data.data.policygrp.length; i++){
                    var val = data.data.policygrp[i];
                    html = "<option value="+val.id+">"+val.name+"</option>";
                    $("#policy_grp").append(html);
                }
                for(var i=0; i<data.data.wangrp.length; i++){
                    var val = data.data.wangrp[i];
                    html = "<option value="+val.value+">"+val.name+"</option>";
                    $("#policy_wan").append(html);
                }
                form.render("select");
            },
        });
    }

    initPage();
    $("#my-shade").remove();
});
