layui.use(['element', 'form', 'table'], function(){
    var $ = layui.$;
    var element = layui.element;
    var form = layui.form;
    var table = layui.table;
    var api = "/cgi-bin/App/opser/userlist"

    //ԶУ
    form.verify({
        isipaddr: function(value, item){
            if(!IsIPAddr(value))
                return "IPַ";
        }
        ,isiprange: function(value, item){
            try{
                var ip = value.split("-");
                var start_ip = ipToNumber(ip[0]);
                var end_ip = ipToNumber(ip[1]);
                var distance = end_ip - start_ip;
                
                if(!IsIPAddr(ip[0])||!IsIPAddr(ip[1]))
                    return "IPΧ";
                
                if(distance <= 0)
                    return "IPҪʼIP";

                if(distance > 256)
                    return "IPΧܴ256";

            }catch(err) {
                return "IPΧ";
            }
        }
    });
    
    //û
    table.render({
        elem: '#user_list'
        ,size: 'sm'
        ,loading: false
        ,cellMinWidth: 80
        ,url: api+'?action=ulist_list'
        ,cols: [[
            {type: 'numbers', title: ''}
            ,{field: 'acct', title: 'û', unresize: true}    
            ,{title: '<a class="layui-btn layui-btn-xs layui-btn-normal" id="add_user"></a>', 
            align:'right', toolbar: '#userlistools', unresize: true}
        ]]
    });

    table.on('tool(user_list)', function(obj){
        var data = obj.data;
        var layEvent = obj.event; 
        if(layEvent === 'edit'){
            layer.open({
                title: '޸˺ţ' + data.acct
                ,anim: 1
                ,type: 1
                ,shadeClose : true
                ,area: ['350px', '220px']
                ,content: $("#editUser").html()
            });
            form.val("EditUser",  {"acct": data.acct});
        } else
        if(layEvent === "del"){
            if(data.acct == "admin"){
                layer.msg("admin˺Ųɾ", {icon: 2, anim: 6});
                return false;
            }
            layer.confirm('ȷҪɾ'+data.acct+'', {icon: 3, title:"ʾ"}, 
            function(index) {
                $.ajax({
                    url: api,
                    type: 'POST',
                    dataType: 'json',
                    data:{"action": "deluser", "acct": data.acct},
                    error: function(xhr, type){},
                    success: function(data){
                        if(data.code == 1)
                            layer.msg(data.msg, {icon: 2, anim: 6});
                        else {
                            layer.msg(data.msg, {icon: 1});
                            table.reloadExt("user_list");
                        }
                    },
                });
            });
        }
    });

    $("#add_user").click(function(){
        layer.open({
            title: '˺'
            ,anim: 1
            ,type: 1
            ,shadeClose : true
            ,area: ['350px', '280px']
            ,content: $("#addUser").html()
        });   
    });

    form.on('switch(madmin_enable)', function(data){
        $.ajax({
            url: api,
            type: 'POST',
            dataType: 'json',
            data:{"action": "madmin_set", "enable": data.elem.checked},
            error: function(xhr, type){},
            success: function(data){
				if(data.code != 0)
					layer.msg(data.msg, {icon:2, anim:6});
				else
					layer.msg(data.msg, {icon: 1});
            },
        });
    });  

    form.on('submit(addUser)', function(data){
        if(data.field.password1 != data.field.password2){
            layer.msg("벻һ", {icon: 2, anim: 6});
            return false;
        }
        data.field.action = "adduser"
        $.ajax({
            url: api,
            type: 'POST',
            dataType: 'json',
            data:data.field,
            error: function(xhr, type){},
            success: function(data){
                if(data.code==1)
                    layer.msg(data.msg, {icon: 2, anim: 6});
                else {
                    layer.closeAll();
                    table.reloadExt("user_list");
                    layer.msg(data.msg, {icon: 1});
                }
            },
        });
        return false;
    });

    form.on('submit(EditUser)', function(data){
        if(data.field.password1 != data.field.password2){
            layer.msg("벻һ", {icon: 2, anim: 6});
            return false;
        }
        data.field.action = "edituser"
        $.ajax({
            url: api,
            type: 'POST',
            dataType: 'json',
            data:data.field,
            error: function(xhr, type){},
            success: function(data){
                if(data.code==1)
                    layer.msg(data.msg, {icon: 2, anim: 6});
                else {
                    layer.closeAll();
                    table.reloadExt("user_list");
                    layer.msg(data.msg, {icon: 1});
                }
            },
        });
        return false;
    });

    //ʿƲ
    element.on('tab(User-Manager-tab)', function(data){
        if (data.index == 0) 
            table.reloadExt("user_list");
        else {
            table.render({
                elem: '#allowip_list'
                ,size: 'sm'
                ,loading: false
                ,cellMinWidth: 80
                ,url: api+'?action=allowip_list'
                ,cols: [[
                    {type: 'checkbox'}
                    ,{type: 'numbers', title: ''}
                    ,{field: 'ip', title: 'IP', unresize: true}
                    ,{title: '<a class="layui-btn layui-btn-xs layui-btn-danger" id="pi_delip">ɾ</a>', 
                    align:'right', toolbar: '#allowiptools', unresize: true}
                ]]
            });
            
            $("#pi_delip").click(function(){
                var checkStatus = table.checkStatus('allowip_list');
                var data = checkStatus.data;
                if ( data.length == 0 ){
                    layer.msg("ǰδѡκIP", {icon: 2, anim: 6});
                    return false;
                }

                layer.confirm('ȷҪɾѡ', {icon: 3, title:"ʾ"}, 
                function(index) {
                    var list = new Array();
                    for(var i = 0; i <= (data.length-1); i++)
                        list.push(data[i].ip);

                    $.ajax({
                        url: api,
                        type: 'POST',
                        dataType: 'json',
                        data:{"action": "allowip_del", "ip": list.toString()},
                        error: function(xhr, type){},
                        success: function(data){
                            if(data.code == 1)
                                layer.msg(data.msg, {icon: 2, anim: 6});
                            else {
                                layer.msg(data.msg, {icon: 1});
                                table.reloadExt("allowip_list");
                            }
                        },
                    });
                });
            });
        }
    });

    form.on('submit(adoneip)', function(data){
        data.field.action = "allowip_add"
        $.ajax({
            url: api,
            type: 'POST',
            dataType: 'json',
            data:data.field,
            error: function(xhr, type){},
            success: function(data){
                if(data.code==1)
                    layer.msg(data.msg, {icon: 2, anim: 6});
                else {
                    table.reloadExt("allowip_list");
                    layer.msg(data.msg, {icon: 1});
                }
            },
        });
        return false;
    });

    form.on('submit(addrangeip)', function(data){
        var start_ip = ipToNumber(data.field.rangeip.split("-")[0]);
        var end_ip = ipToNumber(data.field.rangeip.split("-")[1]);
        var iplist = new Array();
        
        for(i=start_ip; i<=end_ip; i++)
            iplist.push(numberToIp(i));
        
        data.field.ip = iplist.toString();
        data.field.action = "allowip_add"
        $.ajax({
            url: api,
            type: 'POST',
            dataType: 'json',
            data:data.field,
            error: function(xhr, type){},
            success: function(data){
                if(data.code==1)
                    layer.msg(data.msg, {icon: 2, anim: 6});
                else {
                    table.reloadExt("allowip_list");
                    layer.msg(data.msg, {icon: 1});
                }
            },
        });
        return false;
    });

    table.on('tool(allowip_list)', function(obj){
        var data = obj.data;
        var layEvent = obj.event; 
        if(layEvent === "del"){
            layer.confirm('ȷҪɾ'+data.ip+'', {icon: 3, title:"ʾ"}, 
            function(index) {
                $.ajax({
                    url: api,
                    type: 'POST',
                    dataType: 'json',
                    data:{"action": "allowip_del", "ip": data.ip},
                    error: function(xhr, type){},
                    success: function(data){
                        if(data.code == 1)
                            layer.msg(data.msg, {icon: 2, anim: 6});
                        else {
                            layer.msg(data.msg, {icon: 1});
                            table.reloadExt("allowip_list");
                        }
                    },
                });
            });
        }
    });
            
    function ipToNumber(ip) { 
        var num = 0; 
        if(ip == "") { 
            return num; 
        }   
        var aNum = ip.split(".");  
        if(aNum.length != 4) { 
            return num; 
        }   
        num += parseInt(aNum[0]) << 24; 
        num += parseInt(aNum[1]) << 16; 
        num += parseInt(aNum[2]) << 8; 
        num += parseInt(aNum[3]) << 0; 
        num = num >>> 0;
        return num;  
    }   
   
    function numberToIp(number) {   
        var ip = ""; 
        if(number <= 0) { 
            return ip; 
        }
        var ip3 = (number << 0 ) >>> 24; 
        var ip2 = (number << 8 ) >>> 24; 
        var ip1 = (number << 16) >>> 24; 
        var ip0 = (number << 24) >>> 24 
        ip += ip3 + "." + ip2 + "." + ip1 + "." + ip0; 
        return ip;   
    }
    
    //ҳʼ
    function initPage(){
        $.ajax({
            url: api,
            type: 'POST',
            dataType: 'json',
            data:{"action": "madmin_load"},
            error: function(xhr, type){},
            success: function(data){
                if(data.msg != "")
                    form.val("act_enable", {"isenable": true});
            },
        });
    }
    
    window.setboxHeight = function(){
        var height = window.parent.document.documentElement.clientHeight - 80;
        var obj = document.getElementById("card-content");
        obj.style.height = height +"px";   
    }

    initPage();
    setboxHeight();
    $("#my-shade").remove();
});
